=== debian/changelog ===
libengine-gost-openssl (3.0.1-2) unstable; urgency=medium

  * Add pkg-config to Build-Depends (Closes: #1014070) 

 -- Wartan Hachaturow <wart@debian.org>  Thu, 30 Jun 2022 15:02:22 +0300

libengine-gost-openssl (3.0.1-1) unstable; urgency=medium

  * Wohoo-my-gpg-key-works-again release
  * Upgrade to OpenSSL 3.0 engine branch, rename package
  * Fix for CVE-2022-29242 (Closes: #1012512)
  * Deprecate 1.1 package version.
  * Update debian/copyright

 -- Wartan Hachaturow <wart@debian.org>  Mon, 13 Jun 2022 00:38:39 +0300

libengine-gost-openssl1.1 (1.1.0.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * d/watch: Scan GitHub tags.

  [ Helmut Grohne ]
  * Fix openssl engine path for cross compilation (Closes: #966642).

  [ Simon Chopin ]
  * Stopgap patches for OpenSSL3 before migrating to provider API:
    - d/rules: downgrade deprecation errors to warnings to fix the build
      against OpenSSL 3 (Closes: #1006391)
    - d/p/OpenSSL3.patch: Fix several const-correctness issues introduced
      by OpenSSL 3 API changes.

 -- Bastian Germann <bage@debian.org>  Sat, 21 May 2022 00:33:51 +0200

libengine-gost-openssl1.1 (1.1.0.3-1) unstable; urgency=medium

  * New upstream version
  * Closes: #898823, #906734

 -- Wartan Hachaturow <wart@debian.org>  Sun, 16 Sep 2018 18:58:16 +0300

libengine-gost-openssl1.1 (1.1.0.1-1) unstable; urgency=low

  * Initial upload
  * Closes: #870625

 -- Wartan Hachaturow <wart@debian.org>  Fri, 11 Aug 2017 19:34:28 +0300
