=== debian/control ===
Source: libengine-gost-openssl
Section: libs
Priority: optional
Maintainer: Wartan Hachaturow <wart@debian.org>
Build-Depends: debhelper (>= 13), cmake, libssl-dev, openssl, pkg-config
Standards-Version: 3.9.5
Homepage: https://github.com/gost-engine/engine
Vcs-Git: https://github.com/gost-engine/engine.git

Package: libengine-gost-openssl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libengine-gost-openssl1.1 (<< 3.0.1-1)
Replaces: libengine-gost-openssl1.1 (<< 3.0.1-1)
Provides: libengine-gost-openssl1.1
Description: Loadable module for openssl implementing GOST algorithms
 This package contains loadable module for openssl library, which
 implements (in software) Russian national standard (GOST) cryptography

Package: libengine-gost-openssl1.1
Section: oldlibs
Architecture: any
Depends: libengine-gost-openssl (= ${binary:Version}), ${misc:Depends}
Description: dummy package for upgrades from libengine-gost-openssl1.1
 Can be safely removed.

Package: gostsum
Architecture: any
Section: utils
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Utility to compute GOST hashes
 This package contain utilities to compute GOST hashsums
 gostsum - computes GOST R 34.11-94 hash
 gost12sum - computes GOST R 34.11-2012 hash
