=== debian/changelog ===
libengine-gost-openssl (3.0.2-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:46:19 +1100

libengine-gost-openssl (3.0.2-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 18:22:54 +0000

libengine-gost-openssl (3.0.2-1) unstable; urgency=medium

  * New upstream version
  * Includes fix for gcc13 (Closes: #1037726)

 -- Wartan Hachaturow <wart@debian.org>  Mon, 14 Aug 2023 23:59:32 +0300
