## libengine-gost-openssl 3.0.3%2Bgit20251212.7f6d61a

=== debian/rules ===
--- 
+++ 
@@ -25,6 +25,9 @@
 %:
 	dh $@ 
 
+override_dh_auto_test:
+	dh_auto_test --no-parallel
+
 # Please also look if there are files or directories which have a
 # different copyright/license attached and list them here.
 # Please avoid to pick license terms that are more restrictive than the
