=== debian/changelog ===
libengine-gost-openssl (3.0.3+git20251212.7f6d61a-1) unstable; urgency=medium

  * Remove debian/compat to comply with new debhelper rules.
  * Latest commit from upstream git repository
  * Cross-builds to s390x, (Closes: #1054922)
  * Builds with cmake 4 (Closes: #1113146)
  * Fix race condition on test phase (Closes: #1115372)

 -- Wartan Hachaturow <wart@debian.org>  Tue, 06 Jan 2026 21:24:39 +0300
