=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: libengine-gost-openssl
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Wartan Hachaturow <wart@debian.org>
-Build-Depends: debhelper (>= 13), cmake, libssl-dev, openssl, pkg-config
+Maintainer: Wartan Hachaturow <wart@debian.org>
+Build-Depends: debhelper-compat (= 13), cmake, libssl-dev, openssl, pkg-config
 Standards-Version: 3.9.5
 Homepage: https://github.com/gost-engine/engine
 Vcs-Git: https://github.com/gost-engine/engine.git
